<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): SymbolScope.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_symbol_scope_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">SymbolScope.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2014, Freescale Semiconductor, Inc.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright 2016 NXP</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * All rights reserved.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without modification,</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * o Redistributions of source code must retain the above copyright notice, this list</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *   of conditions and the following disclaimer.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * o Redistributions in binary form must reproduce the above copyright notice, this</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *   list of conditions and the following disclaimer in the documentation and/or</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *   other materials provided with the distribution.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * o Neither the name of the copyright holder nor the names of its</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   contributors may be used to endorse or promote products derived from this</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   software without specific prior written permission.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#ifndef _EMBEDDED_RPC__SYMBOLSCOPE_H_</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#define _EMBEDDED_RPC__SYMBOLSCOPE_H_</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;Symbol.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">// Classes</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceerpcgen.html">erpcgen</a> {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html">   49</a></span>&#160;<span class="keyword">class </span><a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">typedef</span> std::map&lt;std::string, Symbol *&gt; symbol_map_t;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">typedef</span> std::vector&lt;Symbol *&gt; symbol_vector_t;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">   55</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    {</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">typedef</span> symbol_vector_t::iterator vit;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">typedef</span> vit::value_type value_type;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">operator</span> value_type &amp;() { <span class="keywordflow">return</span> *m_vec; }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        value_type &amp;operator*() { <span class="keywordflow">return</span> *m_vec; }</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        value_type &amp;operator-&gt;() { <span class="keywordflow">return</span> *m_vec; }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a> &amp;operator++();</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordtype">bool</span> operator==(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a> &amp;other) { <span class="keywordflow">return</span> (m_vec == other.m_vec); }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordtype">bool</span> operator!=(<span class="keyword">const</span> <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a> &amp;other) { <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == other); }</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        symbol_vector_t::iterator m_vec;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        symbol_vector_t::iterator m_endvec;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <a class="code" href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">Symbol::symbol_type_t</a> m_predicateType;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a>(<span class="keyword">const</span> vit &amp;bv, <span class="keyword">const</span> vit &amp;ev, <a class="code" href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">Symbol::symbol_type_t</a> predicateType);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    };</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a>()</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    : <a class="code" href="classerpcgen_1_1_symbol_scope.html#afa85b7509f8796e12078070b81c88bd9">m_symbolMap</a>()</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    , <a class="code" href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">m_symbolVector</a>()</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    , <a class="code" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">m_parent</a>(<span class="keyword">nullptr</span>)</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    {</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#aa6e6f9ed5494233710e5138fbd13780d">  100</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#aa6e6f9ed5494233710e5138fbd13780d">~SymbolScope</a>() {}</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a0a2f5172c058ac07bdc862cf26e49586">hasSymbol</a>(<span class="keyword">const</span> std::string &amp;name, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <a class="code" href="classerpcgen_1_1_symbol.html">Symbol</a> *<a class="code" href="classerpcgen_1_1_symbol_scope.html#a307cfc7cdbb201f06062fddf48b4948a">getSymbol</a>(<span class="keyword">const</span> std::string &amp;name, <span class="keywordtype">bool</span> recursive = <span class="keyword">true</span>);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#ad6f6456fc5ade11b91ecc2aa627d7b05">addSymbol</a>(<a class="code" href="classerpcgen_1_1_symbol.html">Symbol</a> *sym, int32_t pos = -1);</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a2c3bd345058aef148a708c7eb8cf6413">replaceSymbol</a>(<a class="code" href="classerpcgen_1_1_symbol.html">Symbol</a> *oldSym, <a class="code" href="classerpcgen_1_1_symbol.html">Symbol</a> *newSym);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    int32_t <a class="code" href="classerpcgen_1_1_symbol_scope.html#a7384e2d0f0b23f936cb4d6ca9b4cc516">getSymbolPos</a>(<a class="code" href="classerpcgen_1_1_symbol.html">Symbol</a> *sym);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a57a3ab7772138826666b2ec82ac5ad1a">  185</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a57a3ab7772138826666b2ec82ac5ad1a">hasParent</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">m_parent</a> != <span class="keyword">nullptr</span>; }</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a740e7cba7d12e1f06c0ad4485f102dd2">  192</a></span>&#160;    <a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a> *<a class="code" href="classerpcgen_1_1_symbol_scope.html#a740e7cba7d12e1f06c0ad4485f102dd2">getParent</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">m_parent</a>; }</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a33629ec70cf05217b9d3108b71d8b272">  199</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a33629ec70cf05217b9d3108b71d8b272">setParent</a>(<a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a> *parent) { <a class="code" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">m_parent</a> = parent; }</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a196cd4e878bd90f4e361fb902db3a803">  206</a></span>&#160;    symbol_vector_t::iterator <a class="code" href="classerpcgen_1_1_symbol_scope.html#a196cd4e878bd90f4e361fb902db3a803">begin</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">m_symbolVector</a>.begin(); }</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#ad93cefc5d50fe7d4c7adff65bd950db3">  213</a></span>&#160;    symbol_vector_t::iterator <a class="code" href="classerpcgen_1_1_symbol_scope.html#ad93cefc5d50fe7d4c7adff65bd950db3">end</a>() { <span class="keywordflow">return</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">m_symbolVector</a>.end(); }</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a> <a class="code" href="classerpcgen_1_1_symbol_scope.html#ac218822927764b4e97cc80542921f44e">tbegin</a>(<a class="code" href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">Symbol::symbol_type_t</a> predicateType);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <a class="code" href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">typed_iterator</a> <a class="code" href="classerpcgen_1_1_symbol_scope.html#ad8bc35f9038134ad31ece81cfafb6832">tend</a>(<a class="code" href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">Symbol::symbol_type_t</a> predicateType);</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    symbol_vector_t <a class="code" href="classerpcgen_1_1_symbol_scope.html#a57d278b24988d3e7555399e3813e9d84">getSymbolsOfType</a>(<a class="code" href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">Symbol::symbol_type_t</a> predicateType);</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#a58441c72b0d42da17a182f34c56f748e">dump</a>();</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classerpcgen_1_1_symbol_scope.html#ac25fb1094b51511a71ea057273086a7f">clear</a>();</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00263"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#afa85b7509f8796e12078070b81c88bd9">  263</a></span>&#160;    symbol_map_t <a class="code" href="classerpcgen_1_1_symbol_scope.html#afa85b7509f8796e12078070b81c88bd9">m_symbolMap</a>;       </div><div class="line"><a name="l00264"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">  264</a></span>&#160;    symbol_vector_t <a class="code" href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">m_symbolVector</a>; </div><div class="line"><a name="l00265"></a><span class="lineno"><a class="line" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">  265</a></span>&#160;    <a class="code" href="classerpcgen_1_1_symbol_scope.html">SymbolScope</a> *<a class="code" href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">m_parent</a>;          </div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;};</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;} <span class="comment">// namespace erpcgen</span></div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="preprocessor">#endif // _EMBEDDED_RPC__SYMBOLSCOPE_H_</span></div><div class="ttc" id="classerpcgen_1_1_symbol_scope_html_ad93cefc5d50fe7d4c7adff65bd950db3"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#ad93cefc5d50fe7d4c7adff65bd950db3">erpcgen::SymbolScope::end</a></div><div class="ttdeci">symbol_vector_t::iterator end()</div><div class="ttdoc">Return end of symbol vector. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:213</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a2c3bd345058aef148a708c7eb8cf6413"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a2c3bd345058aef148a708c7eb8cf6413">erpcgen::SymbolScope::replaceSymbol</a></div><div class="ttdeci">void replaceSymbol(Symbol *oldSym, Symbol *newSym)</div><div class="ttdoc">This function will replace old symbol with new symbol in the symbol scope. </div><div class="ttdef"><b>Definition:</b> Type.cpp:229</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_ad8bc35f9038134ad31ece81cfafb6832"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#ad8bc35f9038134ad31ece81cfafb6832">erpcgen::SymbolScope::tend</a></div><div class="ttdeci">typed_iterator tend(Symbol::symbol_type_t predicateType)</div><div class="ttdef"><b>Definition:</b> Type.cpp:150</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_ad6f6456fc5ade11b91ecc2aa627d7b05"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#ad6f6456fc5ade11b91ecc2aa627d7b05">erpcgen::SymbolScope::addSymbol</a></div><div class="ttdeci">void addSymbol(Symbol *sym, int32_t pos=-1)</div><div class="ttdoc">This function will add symbol to the symbol scope. </div><div class="ttdef"><b>Definition:</b> Type.cpp:195</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_aa6e6f9ed5494233710e5138fbd13780d"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#aa6e6f9ed5494233710e5138fbd13780d">erpcgen::SymbolScope::~SymbolScope</a></div><div class="ttdeci">virtual ~SymbolScope()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:100</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a307cfc7cdbb201f06062fddf48b4948a"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a307cfc7cdbb201f06062fddf48b4948a">erpcgen::SymbolScope::getSymbol</a></div><div class="ttdeci">Symbol * getSymbol(const std::string &amp;name, bool recursive=true)</div><div class="ttdoc">This function will return symbol. </div><div class="ttdef"><b>Definition:</b> Type.cpp:178</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a57a3ab7772138826666b2ec82ac5ad1a"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a57a3ab7772138826666b2ec82ac5ad1a">erpcgen::SymbolScope::hasParent</a></div><div class="ttdeci">bool hasParent() const </div><div class="ttdoc">Return boolean representation about existence of parent. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:185</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_ac25fb1094b51511a71ea057273086a7f"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#ac25fb1094b51511a71ea057273086a7f">erpcgen::SymbolScope::clear</a></div><div class="ttdeci">void clear()</div><div class="ttdoc">Erase data from m_symbolMap and m_symbolVector. </div><div class="ttdef"><b>Definition:</b> Type.cpp:267</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_html"><div class="ttname"><a href="classerpcgen_1_1_symbol.html">erpcgen::Symbol</a></div><div class="ttdoc">Base class for all named declarations in the IDL. </div><div class="ttdef"><b>Definition:</b> Symbol.h:49</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a196cd4e878bd90f4e361fb902db3a803"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a196cd4e878bd90f4e361fb902db3a803">erpcgen::SymbolScope::begin</a></div><div class="ttdeci">symbol_vector_t::iterator begin()</div><div class="ttdoc">Return begin of symbol vector. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:206</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a70bd77c5e4d69529252dece2b30a6b0c"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a70bd77c5e4d69529252dece2b30a6b0c">erpcgen::SymbolScope::m_symbolVector</a></div><div class="ttdeci">symbol_vector_t m_symbolVector</div><div class="ttdef"><b>Definition:</b> SymbolScope.h:264</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a33629ec70cf05217b9d3108b71d8b272"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a33629ec70cf05217b9d3108b71d8b272">erpcgen::SymbolScope::setParent</a></div><div class="ttdeci">void setParent(SymbolScope *parent)</div><div class="ttdoc">This function set parent for this object. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:199</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a57d278b24988d3e7555399e3813e9d84"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a57d278b24988d3e7555399e3813e9d84">erpcgen::SymbolScope::getSymbolsOfType</a></div><div class="ttdeci">symbol_vector_t getSymbolsOfType(Symbol::symbol_type_t predicateType)</div><div class="ttdoc">This function returns symbol vector with symbols. </div><div class="ttdef"><b>Definition:</b> Type.cpp:155</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_ac218822927764b4e97cc80542921f44e"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#ac218822927764b4e97cc80542921f44e">erpcgen::SymbolScope::tbegin</a></div><div class="ttdeci">typed_iterator tbegin(Symbol::symbol_type_t predicateType)</div><div class="ttdef"><b>Definition:</b> Type.cpp:145</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a0a2f5172c058ac07bdc862cf26e49586"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a0a2f5172c058ac07bdc862cf26e49586">erpcgen::SymbolScope::hasSymbol</a></div><div class="ttdeci">bool hasSymbol(const std::string &amp;name, bool recursive=true)</div><div class="ttdoc">This function returns true when name is found in symbol map. </div><div class="ttdef"><b>Definition:</b> Type.cpp:168</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html">erpcgen::SymbolScope</a></div><div class="ttdoc">A scoped namespace containing symbols. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:49</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a740e7cba7d12e1f06c0ad4485f102dd2"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a740e7cba7d12e1f06c0ad4485f102dd2">erpcgen::SymbolScope::getParent</a></div><div class="ttdeci">SymbolScope * getParent()</div><div class="ttdoc">Return pointer to parent. </div><div class="ttdef"><b>Definition:</b> SymbolScope.h:192</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_1_1typed__iterator_html"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope_1_1typed__iterator.html">erpcgen::SymbolScope::typed_iterator</a></div><div class="ttdef"><b>Definition:</b> SymbolScope.h:55</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_afa85b7509f8796e12078070b81c88bd9"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#afa85b7509f8796e12078070b81c88bd9">erpcgen::SymbolScope::m_symbolMap</a></div><div class="ttdeci">symbol_map_t m_symbolMap</div><div class="ttdef"><b>Definition:</b> SymbolScope.h:263</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a7384e2d0f0b23f936cb4d6ca9b4cc516"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a7384e2d0f0b23f936cb4d6ca9b4cc516">erpcgen::SymbolScope::getSymbolPos</a></div><div class="ttdeci">int32_t getSymbolPos(Symbol *sym)</div><div class="ttdoc">This function will return symbol position. </div><div class="ttdef"><b>Definition:</b> Type.cpp:245</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a58441c72b0d42da17a182f34c56f748e"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a58441c72b0d42da17a182f34c56f748e">erpcgen::SymbolScope::dump</a></div><div class="ttdeci">void dump()</div><div class="ttdoc">This function show debug description about the all symbols. </div><div class="ttdef"><b>Definition:</b> Type.cpp:257</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_scope_html_a85b468ab0a65570b60f62dfbd883d35f"><div class="ttname"><a href="classerpcgen_1_1_symbol_scope.html#a85b468ab0a65570b60f62dfbd883d35f">erpcgen::SymbolScope::m_parent</a></div><div class="ttdeci">SymbolScope * m_parent</div><div class="ttdef"><b>Definition:</b> SymbolScope.h:265</div></div>
<div class="ttc" id="classerpcgen_1_1_symbol_html_a41dbbe424222a8e9b4b73c390cf06775"><div class="ttname"><a href="classerpcgen_1_1_symbol.html#a41dbbe424222a8e9b4b73c390cf06775">erpcgen::Symbol::symbol_type_t</a></div><div class="ttdeci">symbol_type_t</div><div class="ttdoc">Supported symbol types. </div><div class="ttdef"><b>Definition:</b> Symbol.h:55</div></div>
<div class="ttc" id="namespaceerpcgen_html"><div class="ttname"><a href="namespaceerpcgen.html">erpcgen</a></div><div class="ttdef"><b>Definition:</b> AstNode.h:47</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
